package com.company.jmixtest.screen.testentity

import com.company.jmixtest.entity.TestEntity
import io.jmix.core.metamodel.model.MetaPropertyPath
import io.jmix.ui.component.AggregationInfo
import io.jmix.ui.component.GroupTable
import io.jmix.ui.component.Table
import io.jmix.ui.component.data.GroupInfo
import io.jmix.ui.screen.*
import org.springframework.beans.factory.annotation.Autowired

@UiController("jt_TestEntity.browse")
@UiDescriptor("test-entity-browse.xml")
@LookupComponent("testEntitiesTable")
class TestEntityBrowse : StandardLookup<TestEntity>() {
    @Autowired
    private lateinit var testEntitiesTable: GroupTable<TestEntity>


//    private class ColoringGroupCellStyleProvider<E> : GroupTable.GroupStyleProvider<E?> {
//
//        override fun getStyleName(info: GroupInfo<*>): String? {
//            return null
//        }
//
//        override fun getStyleName(entity: E?, property: String?): String {
//            return "test-style"
//        }
//    }

    @Subscribe
    private fun onInit(event: InitEvent) {
        val column = testEntitiesTable.getColumn("value")!!
        val info = AggregationInfo()
        info.type = AggregationInfo.Type.SUM
        info.propertyPath = column.id as MetaPropertyPath
        column.aggregation = info

        testEntitiesTable.addStyleProvider { e, p ->
            "test-style"
        }

//        val tableComposition = testEntitiesTable.unwrapComposition(TableComposition::class.java)
//        val table = tableComposition.table
//        if (table is AggregationContainer)
//            table.addContainerPropertyAggregation(column.id, AggregationContainer.Type.SUM)

//        testEntitiesTable.isAggregatable = true
//        testEntitiesTable.aggregationStyle = Table.AggregationStyle.BOTTOM
    }



}